﻿using C1.WPF.DataGrid;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace StoreGroupInfo_C1DataGrid
{
    public partial class MainWindow : Window
    {
        private readonly ObservableCollection<Employee> _employees = new ObservableCollection<Employee>();
        private Dictionary<int, string> _parents;
        private bool _listSelect;
        private List<Employee> _list;
        private List<Employee> _list2;
        List<Item> items;
        public ObservableCollection<Employee> Employees
        {
            get { return _employees; }
        }
        public MainWindow()
        {
            InitializeComponent();
        }
        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            items = new List<Item>();
            _parents = new Dictionary<int, string>();

            _list = new List<Employee>();
            _list2 = new List<Employee>();
            for (int i = 0; i < 200; i++)
            {
                _list.Add(new Employee());
            }
            for (int i = 0; i < 10; i++)
            {
                _list2.Add(new Employee());
            }
            foreach (var item in _list)
            {
                _employees.Add(item);
            }

            _grid.ItemsSource = _employees;
        }
        private void Button_Click(object sender, RoutedEventArgs e)
        {
            Refresh();
        }
        private void Refresh()
        {
            SaveExpandedRows();

            // get new data 
            _employees.Clear();

            _listSelect = !_listSelect;

            List<Employee> list;

            if (_listSelect)
                list = _list;
            else
                list = _list2;

            foreach (var item in list)
            {
                _employees.Add(item);
            }

            RestoreExpandedRows();
        }
        private void SaveExpandedRows()
        {
            items.Clear();
            _parents.Clear();
            int currentLevel = 0;
            _parents.Add(0, "None");

            for (int i = 0; i <= _grid.Rows.Count - 1; i++)
            {
                DataGridGroupRow gr = _grid.Rows[i] as DataGridGroupRow;
                Item itm;
                if (gr != null)
                {
                    if (gr.Level >= currentLevel)
                    {
                        if (!_parents.ContainsKey(gr.Level + 1))
                        {
                            _parents.Add(gr.Level + 1, gr.GetGroupText());
                        }

                        itm = new Item { Parent = _parents[gr.Level], Name = gr.GetGroupText(), Level = gr.Level, IsCollapsed = gr.GroupRowsVisibility };
                        items.Add(itm);

                        currentLevel = gr.Level;
                    }
                    else
                    {
                        if (_parents.ContainsKey(currentLevel))
                            _parents.Remove(currentLevel);

                        if (!_parents.ContainsKey(gr.Level + 1))
                        {
                            _parents.Add(gr.Level + 1, gr.GetGroupText());
                        }
                        itm = new Item { Parent = _parents[gr.Level], Name = gr.GetGroupText(), Level = gr.Level, IsCollapsed = gr.GroupRowsVisibility };
                        items.Add(itm);

                        currentLevel = gr.Level;
                    }
                }
            }
        }
        private void RestoreExpandedRows()
        {
            _parents.Clear();
            int currentLevel = 0;
            _parents.Add(0, "None");
            Item itm;
            for (int i = 0; i <= _grid.Rows.Count - 1; i++)
            {
                DataGridGroupRow gr = _grid.Rows[i] as DataGridGroupRow;
                if (gr != null)
                {
                    if (gr.Level >= currentLevel)
                    {
                        if (!_parents.ContainsKey(gr.Level + 1))
                        {
                            _parents.Add(gr.Level + 1, gr.GetGroupText());
                        }

                        itm = items.Where(e => e.Parent == _parents[gr.Level] && e.Name == gr.GetGroupText() && e.Level == gr.Level).FirstOrDefault() as Item;
                        if (itm != null)
                            gr.GroupRowsVisibility = itm.IsCollapsed;
                        currentLevel = gr.Level;
                    }
                    else
                    {
                        if (_parents.ContainsKey(currentLevel))
                            _parents.Remove(currentLevel);

                        if (!_parents.ContainsKey(gr.Level + 1))
                        {
                            _parents.Add(gr.Level + 1, gr.GetGroupText());
                        }
                        itm = items.Where(e => e.Parent == _parents[gr.Level] && e.Name == gr.GetGroupText() && e.Level == gr.Level).FirstOrDefault() as Item;
                        if (itm != null)
                            gr.GroupRowsVisibility = itm.IsCollapsed;
                        currentLevel = gr.Level;
                    }
                }
            }
        }
    }
    public class Employee
    {
        Random rand = new Random();
        string[] departments = new string[] { "Administrators", "Users", "Power Users", "Guests" };
        public int ID { get; set; }
        public int Age { get; set; }
        public string Department { get; set; }
        public Employee()
        {
            System.Threading.Thread.Sleep(10);
            ID = rand.Next(26, 71);
            Age = rand.Next(0, 400);
            Department = departments[rand.Next(4)];
        }
    }
    class Item
    {
        public string Parent;
        public string Name;
        public int Level;
        public Visibility IsCollapsed;
        public Item()
        { }
    }
}
